import java.rmi.*;
import java.net.*;
import java.util.*;

/** Diese Klasse dient zur Kommunikation mit dem
  * Messageserver ueber RMI.
  * @author Bernhard Fiser 0109815
  * @version 0.2 2002/10/28 */
public class MessageClient
{
	/* Derzeit implementierte Client Funktionen. */
	private final static int
			GET = 1,
			SEND = 2;

	/** Methode gibt benoetigte Parameter aus. */
	private static void usage()
	{
		System.err.println("INFO: usage:\n Nachricht(en) abholen:\n  java MessageClient get <user>\n Nachricht(en) senden:\n  java MessageClient send <user> <to,to,to,....> <message> <message> ...");
	}

	public static void main(String argv[])
	{
		/* Objekthandle auf RMI-Object. */
		MessageInterface
				obj;
		/* Zieluserarray */
		String		to[];
		/* Nachricht */
		String		msg = "";
		/* Ergebnisarray */
		String[]	msgResult;

		/* Hilfsvariablen. */
		StringTokenizer	t;
		int		mode = 0,
				i;

		/* berprfen ob gengend Argumente bergeben wurden. */
		if (argv.length < 2)
		{
			usage();
			System.exit(1);
		}

		/* Clientfunktion (send|get) feststellen. */
		if (argv[0].compareToIgnoreCase("get") == 0)
			mode = GET;
		else if ((argv[0].compareToIgnoreCase("send") == 0) && (argv.length >= 4))
			mode = SEND;
		/* Falls Funktione nicht feststellbar, Proggie
		 * beenden. */
		else
		{
			usage();
			System.exit(1);
		}

		/* RMI Communication initialisieren. */
		obj = MessageCommunication.init();

		try
		{
			/* RMI je nach Modes send|get aufrufen. */
			switch (mode)
			{
				/* Nachricht vom Server abholen. */
				case GET :
					/* Nachricht(en) abholen. */
					if ((msgResult = obj.getMsg(argv[1])) == null)
					{
						/* Falls keine Nachricht vorhanden
						 * Fehlermeldung ausgeben. */
						System.out.println("\n*** INFO: Es wurde keine Nachrichten fuer dich hinterlegt.");
						break;
					}
					/* Andernfalls Nachrichten ausgeben. */
					System.out.println("\n*** INFO: " + msgResult.length + " Nachrichten wurden hinterlegt.\n");
					for (i = 0; i < msgResult.length; i++)
						System.out.println("Nachricht " + (i + 1) + ": von " + msgResult[i]);
					break;
				/* Nachricht zum Server senden. */
				case SEND :
					t = new StringTokenizer(argv[2], ",");
					i = 0;
					to = new String[t.countTokens()];
					while (t.hasMoreTokens())
						to[i++] = t.nextToken();
					for (i = 3; i < argv.length; i++)
						msg += argv[i] + " ";
					obj.sendMsg(argv[1], to, msg);
					System.out.println("Nachricht am Server gespeichert.");
					break;
				/* Unbekannte Funktion. (Sollte nie vorkommen) */
				default :
					System.err.println("*** ERROR: unbekannte Funktion.");
					usage();
					System.exit(1);
			}
		}
		catch (Exception e)
		{
			System.err.println("MessageClient exception: " + e.getMessage());
			e.printStackTrace();
			System.exit(1);
		}
	}
}

