import java.rmi.*;
import java.net.*;

/** Diese Klasse dient zur Kommunikation mit dem
  * Messageserver ueber RMI.
  * @author Bernhard Fiser 0109815
  * @version 0.2 2002/10/28 */
public class MessageCommunication
{
	/* RMIRegistry Name */
	private static final String	rmiName = "a0109815";
		/* Servername */
	private static final String	webserver = "hanibal.ifs.univie.ac.at";


	public static MessageInterface init()
	{
		/* Objekthandle auf RMI-Object. */
		MessageInterface	obj = null;

		System.out.println("*** INFO: using host: " + webserver);
		/* Security Manager aktivieren. */
		System.setSecurityManager(new RMISecurityManager());

		try
		{
			/* RMI Object auf Remoteserver suchen. */
			obj = (MessageInterface) Naming.lookup("rmi://" + webserver + "/" + rmiName);
			System.out.println("*** INFO: RMI Server gefunden.");

		}
		catch (Exception e)
		{
			System.err.println("***ERROR: MessageCommunication exception: " + e.getMessage());
			e.printStackTrace();
			System.exit(1);
		}

		return(obj);
	}
}

