import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/** Diese Klasse erweitert die Swingklasse JPanel
  * und enthlt alle Elemente zum Empfangen von
  * Nachrichten.
  * @author Bernhard Fiser 0109815
  * @version 0.2 2002/10/28 */
public class XGetMessage extends JPanel implements ActionListener
{
	private String		user;
	private JButton		b;
	private JTextArea	msg;
	private MessageInterface	obj;

	public XGetMessage(MessageInterface obj, String user)
	{
		/* MessageInterface Objekt speichern. */
		this.obj = obj;
		/* Username speichern. */
		this.user = user;

		/* Layout und Rahmen festlegen. */
		this.setLayout(new FlowLayout());
		this.setBorder(new TitledBorder("Nachrichten empfangen"));
		/* Button initialisieren und hinzufgen. */
		this.b = new JButton("Empfangen");
		this.b.addActionListener(this);
		this.add(this.b);
		/* Nachrichtenausgabe Textfeld initialisieren und
		 * hinzufgen. */
		this.msg = new JTextArea(4,40);
		this.msg.setLineWrap(true);
		this.add(new JScrollPane(this.msg));
	}

	/** Diese Methode wird aufgerufen, wenn
	  * der Button gedrckt wurde. */
	public void actionPerformed(ActionEvent event)
	{
		String	msgResult[];
		int	i;

		/* Nachrichten empfangen. */
		try
		{
			/* Prfen, ob Nachrichten vorhanden waren. */
			if ((msgResult = this.obj.getMsg(this.user)) == null)
			{
				/* Falls nicht, Information ausgeben und 
				 * zurckkehren. */
				System.out.println("*** INFO: Keine neue Nachrichten vorhanden.");
				return;
			}
		}
		
		/* Bei Fehlerhaftem Empfangen Fehlermeldung ausgeben. */
		catch (Exception e)
		{
			System.err.println("*** ERROR: Fehler beim Empfangen der Nachrichten.");
			return;
		}

		/* Empfangene Nachrichten zum Textfeld hinzufgen. */
		for (i = 0; i < msgResult.length; i++)
			this.msg.append(msgResult[i] + "\n");
	}
}
